# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server import util


class BandwidthPart(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    def __init__(self, bwp_bandwidth: int=None, bwp_central_frequency: int=None, bwp_numerology: int=None):  # noqa: E501
        """BandwidthPart - a model defined in Swagger

        :param bwp_bandwidth: The bwp_bandwidth of this BandwidthPart.  # noqa: E501
        :type bwp_bandwidth: int
        :param bwp_central_frequency: The bwp_central_frequency of this BandwidthPart.  # noqa: E501
        :type bwp_central_frequency: int
        :param bwp_numerology: The bwp_numerology of this BandwidthPart.  # noqa: E501
        :type bwp_numerology: int
        """
        self.swagger_types = {
            'bwp_bandwidth': int,
            'bwp_central_frequency': int,
            'bwp_numerology': int
        }

        self.attribute_map = {
            'bwp_bandwidth': 'bwp-bandwidth',
            'bwp_central_frequency': 'bwp-central-frequency',
            'bwp_numerology': 'bwp-numerology'
        }
        self._bwp_bandwidth = bwp_bandwidth
        self._bwp_central_frequency = bwp_central_frequency
        self._bwp_numerology = bwp_numerology

    @classmethod
    def from_dict(cls, dikt) -> 'BandwidthPart':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The bandwidth-part of this BandwidthPart.  # noqa: E501
        :rtype: BandwidthPart
        """
        return util.deserialize_model(dikt, cls)

    @property
    def bwp_bandwidth(self) -> int:
        """Gets the bwp_bandwidth of this BandwidthPart.


        :return: The bwp_bandwidth of this BandwidthPart.
        :rtype: int
        """
        return self._bwp_bandwidth

    @bwp_bandwidth.setter
    def bwp_bandwidth(self, bwp_bandwidth: int):
        """Sets the bwp_bandwidth of this BandwidthPart.


        :param bwp_bandwidth: The bwp_bandwidth of this BandwidthPart.
        :type bwp_bandwidth: int
        """

        self._bwp_bandwidth = bwp_bandwidth

    @property
    def bwp_central_frequency(self) -> int:
        """Gets the bwp_central_frequency of this BandwidthPart.


        :return: The bwp_central_frequency of this BandwidthPart.
        :rtype: int
        """
        return self._bwp_central_frequency

    @bwp_central_frequency.setter
    def bwp_central_frequency(self, bwp_central_frequency: int):
        """Sets the bwp_central_frequency of this BandwidthPart.


        :param bwp_central_frequency: The bwp_central_frequency of this BandwidthPart.
        :type bwp_central_frequency: int
        """

        self._bwp_central_frequency = bwp_central_frequency

    @property
    def bwp_numerology(self) -> int:
        """Gets the bwp_numerology of this BandwidthPart.


        :return: The bwp_numerology of this BandwidthPart.
        :rtype: int
        """
        return self._bwp_numerology

    @bwp_numerology.setter
    def bwp_numerology(self, bwp_numerology: int):
        """Sets the bwp_numerology of this BandwidthPart.


        :param bwp_numerology: The bwp_numerology of this BandwidthPart.
        :type bwp_numerology: int
        """

        self._bwp_numerology = bwp_numerology
